import java.sql.*;

public class Main {

	static final String JDBC_DRIVER = "com.mysql.jdbc.Driver";
	static final String DB_URL = "jdbc:mysql://mysqlweb1.d.ethz.ch/";

	/**
	 * !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	 * ! Change these lines              !
	 * ! Be connected to the ETH network !
	 * !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	 */
	
	static final String USER = "YOUR-NETHZ-USERNAME-HERE";
	static final String PASS = "YOUR-DB-PASSWORD-HERE";

	/**
	 * Main method establishes and closes DB connection
	 */
	public static void main(String[] args) {
		Connection connection = null;
		try {
			// Connect to database
			System.out.println("Connecting to database...");
			Class.forName("com.mysql.jdbc.Driver");
			connection = DriverManager.getConnection(DB_URL + USER, USER, PASS);

			// Execute queries
			System.out.println("Executing SQL queries...");
			printAllStudentsWithMinSemester(connection, 2);
			printAllProfessorsByRank(connection, "FP");
			printAllUniversityMembers(connection);

			// Closing the connection
			System.out.println("Clocing connection...");
			connection.close();
		} catch (SQLException e) {
			System.out.println("There was a problem with one of the statements.");
		} catch (ClassNotFoundException e) {
			System.out.println("Cannot find the JDBC driver. Check under Project Settings > Build Path.");
		}
	}

	/**
	 * Example query which prints all students enrolled in or above a specific semster
	 * @param connection Connection to the database
	 * @param minimumSemester Minimum semester
	 */
	public static void printAllStudentsWithMinSemester(Connection connection,
			int minimumSemester) throws SQLException {

		System.out.println("-----------------");
		System.out.println("Query 1");
		System.out.println("-----------------");

		// Prepare the query and set the first argument (i.e. the minimum
		// semester replaces the ?)
		PreparedStatement stmt = connection
				.prepareStatement("SELECT * FROM Studenten WHERE Semester >= ?");
		stmt.setInt(1, minimumSemester);

		// Execute the query
		stmt.execute();

		// Get the results
		ResultSet results = stmt.getResultSet();

		// Read all the results and print the name and semester
		while (results.next()) {
			String n = results.getString("Name");
			int s = results.getInt("Semester");
			System.out.println("Name: " + n + " | " + "Semester: " + s);
		}
		
		results.close();
		stmt.close();

		System.out.println("-----------------");
		System.out.println();

	}

	/**
	 * Print all the professors of a specific rank
	 * @param connection Connection to the database
	 * @param rank The rank of the professor
	 */
	public static void printAllProfessorsByRank(Connection connection, String rank) throws SQLException {

		System.out.println("-----------------");
		System.out.println("Query 2");
		System.out.println("-----------------");

		// TODO Prepare the query and set rank argument
		PreparedStatement stmt = null;
				
		// TODO Remove this line when solving the exercise
		if (stmt == null) return;
				
		// Execute the query
		stmt.execute();

		// Get the results
		ResultSet results = stmt.getResultSet();

		// Read all the results and print the name and rank
		while (results.next()) {
			String n = results.getString("Name");
			String r = results.getString("Rang");
			System.out.println("Name: " + n + " | " + "Rang: " + r);
		}
		
		results.close();
		stmt.close();

		System.out.println("-----------------");
		System.out.println();

	}
	
	/**
	 * Print all the university members as well as their Id-Number (PersNr or Legi).
	 * @param connection Connection to the database
	 */
	public static void printAllUniversityMembers(Connection connection) throws SQLException {
		
		System.out.println("-----------------");
		System.out.println("Query 3");
		System.out.println("-----------------");
		
		// TODO Prepare the query and set any arguments if necessary
		PreparedStatement stmt = null;
		
		// TODO Remove this line when solving the exercise
		if (stmt == null) return;
		
		// Execute the query
		stmt.execute();

		// Get the results
		ResultSet results = stmt.getResultSet();
		
		// Iterate over the results and print the ID and the name
		while (results.next()) {
			// TODO print the name and id of the person
		}

		results.close();
		stmt.close();

		System.out.println("-----------------");
		System.out.println();
		
	}

}
